import numpy as np
import matplotlib.pyplot as plt
import matplotlib.image as mpimg


def imread(image, grayscale=False):
    imgnp = mpimg.imread(image)
    img = imgnp.tolist()
    if grayscale and type(img[0][0]) != int:
        img = [[x[0] for x in y] for y in img]
    return img

cpt = 0

def imshow(tab, grayscale=False, norm=True):
    global cpt
    plt.figure(cpt)
    cpt = cpt + 1
    if grayscale:
        if norm:
            tab = np.array(tab)
            plt.imshow(tab, cmap='gray')
        else:
            tab = np.array(tab)
            plt.imshow(tab, cmap='gray', vmin=0, vmax=255)
    else:
        tab = np.array(tab, dtype=np.uint8)
        plt.imshow(tab)
    plt.show(block=False)

def imsave(tab, name, grayscale=False, no_norm=False):
    if grayscale:
        if no_norm:
            tab = np.array(tab)
            plt.imsave(name, tab, cmap='gray')
        else:
            tab = np.array(tab)
            plt.imsave(name, tab, cmap='gray', vmin=0, vmax=255)
    else:
        tab = np.array(tab, dtype=np.uint8)
        mpimg.imsave(name, tab)

